import React, { createContext, useState, useEffect } from "react";
import PropTypes from "prop-types";
import { format } from "date-fns";

const timerDuration = 10000;
const utcTime = new Date(new Date().toUTCString().slice(0, -3));

const handleAllAsterisk = (task) => {
  const { fn } = task;
  setInterval(() => {
    console.log("utc::", utcTime);
    fn();
  }, timerDuration);
};

console.log("utc::", utcTime);

const validate = (splitted) => {
  const utcTime = new Date(new Date().toUTCString().slice(0, -3));
  // console.log("utc::", utc);
  const currentMin = format(utcTime, "m");
  const currentHour = format(utcTime, "H");
  const currentDom = format(utcTime, "d");
  const currentMon = format(utcTime, "M");
  // const m = format(utcTime, "m");
  // console.log("utc::", utcTime);
  // console.log("m::", currentMin, currentHour, currentDom, currentMon);

  const min = splitted[0];
  const hour = splitted[1];
  const dom = splitted[2];
  const mon = splitted[3];
  // const dow = splitted[4];
  if (min !== "*" && min !== currentMin) {
    return { error: true, col: "in" };
  }
  if (hour !== "*" && hour !== currentHour) {
    return { error: true, col: "hour" };
  }
  if (dom !== "*" && dom !== currentDom) {
    return { error: true, col: "dom" };
  }
  if (mon !== "*" && mon !== currentMon) {
    return { error: true, col: "mon" };
  }

  return { error: false, col: null };
};

const handleOthers = (splitted, task) => {
  const { fn } = task;

  setInterval(() => {
    const res = validate(splitted);
    if (!res.error) {
      console.log("utc::", utcTime);

      fn();
    } else {
      // console.log("not validated task ::", task);
    }
  }, timerDuration);
};

const handleSetTimer = (task) => {
  const { fn, config } = task;
  const splitted = config.split("-");
  const notAsterisk = splitted
    .slice(0, splitted.length - 1)
    .find((item) => item !== "*");
  if (!notAsterisk) {
    console.log("all asterisk ::", task);
    handleAllAsterisk(task);
  } else {
    // means there is something particular
    handleOthers(splitted, task);
  }
};

const CronContext = createContext(null);

const CronProvider = ({ children, tasks }) => {
  useEffect(() => {
    if (tasks.length) {
      for (const item of tasks) {
        handleSetTimer(item);
      }
    }
  }, [tasks]);

  const store = {
    tasks,
  };
  return <CronContext.Provider value={store}>{children}</CronContext.Provider>;
};

CronProvider.propTypes = {
  tasks: PropTypes.array.isRequired,
};

CronProvider.defaultProps = {
  tasks: [],
};

export { CronProvider, CronContext };
